//------------------------------------------------------------------
// original can be found here http://www.trade2win.com/boards/forex-strategies-systems/71854-correlation-trading-basic-ideas-strategies-64.html
// this version was made by mladen
// ideas and mods by snowski
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_level1 0.0

extern string Parameters                  = "FXCorrelator_4.20";
extern int    PerAvr                      = 20;
extern int    Delta                       = 1;
extern double Smooth                      = 3;
extern double SmoothPhase                 = 0;

extern color  EURColor                    = RoyalBlue;
extern color  USDColor                    = Magenta;
extern color  histoColor                  = Silver;
extern int    LinesWidth                  = 1;
extern string SymbolPrefix                = "";
extern string SymbolSuffix                = "";

extern bool   ArrowsOnSlope               = true;

extern bool   markBothOnSameSide          = true;
extern int    markSymbol                  = 119;
extern color  markBothBelowColor          = RoyalBlue;
extern color  markBothAboveColor          = Magenta;
extern double markDistance                = 1.5;
extern double markSensitivity             = 0.00005;

extern string UniqueID                    = "FXCorr_4.20";
extern int    ShowBars                    = 500;

double EUR_dx[],USD_dx[],histo[], delta[];
string Currencies[] = {"EUR","USD"};
int    Colors[2];
string ShortName;
bool   returnBars;
string indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer (0, histo);
   SetIndexStyle  (0, DRAW_HISTOGRAM,STYLE_SOLID, 3, histoColor);
   SetIndexBuffer (1, EUR_dx);
   SetIndexBuffer (2, USD_dx);
   
   Colors[0] = EURColor; Colors[1] = USDColor;
  
      indicatorFileName = WindowExpertName();
      returnBars        = (Parameters=="returnBars");
      ShortName         = UniqueID+" ("+PerAvr+"/"+Delta+")";

   IndicatorShortName(ShortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--) {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define ystep 17

int start() 
{  
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-1,Bars-counted_bars);
         if (returnBars) { histo[0]=limit; return(0); }

         //
         //
         //
         //
         //
                  
         static bool initialized = false;
            if (!initialized )
            {
               int x      = 40;
               int y      = 10;
               int window = WindowFind(ShortName);

                  for (int i = 1; i<3; i++, y+=ystep)
                  {
                     SetIndexLabel(i,Currencies[i-1]);
                     SetIndexStyle(i,DRAW_LINE,EMPTY,LinesWidth,Colors[i-1]); 
                     
                        string name = UniqueID+"obj_"+Currencies[i-1];
                           ObjectCreate(name,OBJ_LABEL,window,0,0);
                              ObjectSet(name,OBJPROP_XDISTANCE,x);
                              ObjectSet(name,OBJPROP_YDISTANCE,y);
                              ObjectSet(name,OBJPROP_CORNER,1);
                              ObjectSetText(name,Currencies[i-1],10,"Arial bold",Colors[i-1]);
                  }
                  initialized = true;
            }
            checkLimit("EURUSD",limit);
            checkLimit("GBPUSD",limit);
            checkLimit("AUDUSD",limit);
            checkLimit("USDCHF",limit);
            checkLimit("USDJPY",limit);
            checkLimit("NZDUSD",limit);
            checkLimit("USDCAD",limit);

         //
         //
         //
         //
         //
             
   for (i=limit; i>=0; i--)    
   {
      double A1 = (iMA(SymbolPrefix+"EURUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i)      -iMA(SymbolPrefix+"EURUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta))/1; 
      double A2 = (iMA(SymbolPrefix+"GBPUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i)      -iMA(SymbolPrefix+"GBPUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta))/1; 
      double A3 = (iMA(SymbolPrefix+"AUDUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i)      -iMA(SymbolPrefix+"AUDUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta))/1; 
      double A4 = (iMA(SymbolPrefix+"USDCHF"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta)-iMA(SymbolPrefix+"USDCHF"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i      ))/1;
      double A5 = (iMA(SymbolPrefix+"USDJPY"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta)-iMA(SymbolPrefix+"USDJPY"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i      ))/100; 
      double A6 = (iMA(SymbolPrefix+"NZDUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i)      -iMA(SymbolPrefix+"NZDUSD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta))/1;
      double A7 = (iMA(SymbolPrefix+"USDCAD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i+Delta)-iMA(SymbolPrefix+"USDCAD"+SymbolSuffix,0,PerAvr,0,MODE_LWMA,PRICE_CLOSE,i      ))/1;
      
      double USD = -(A1+A2+A3+A4+A5+A6+A7)/7;
      double EUR =  A1-(A2+A3+A4+A5+A6+A7)/6;
      double GBP =  A2-(A1+A3+A4+A5+A6+A7)/6;
      double AUD =  A3-(A1+A2+A4+A5+A6+A7)/6;     
      double CHF =  A4-(A1+A2+A3+A5+A6+A7)/6;  
      double JPY =  A5-(A1+A2+A3+A4+A6+A7)/6;
      double NZD =  A6-(A1+A2+A3+A4+A5+A7)/6;
      double CAD =  A7-(A1+A2+A3+A4+A5+A6)/6;

      EUR_dx[i] = iSmooth(EUR,Smooth,SmoothPhase,i,0); checkRiseFall(EUR_dx,0,i);
      USD_dx[i] = iSmooth(USD,Smooth,SmoothPhase,i,1); checkRiseFall(USD_dx,1,i);

      histo[i] = EUR_dx[i] - USD_dx[i]; 
   
      //
      //
      //
      //
      //
         
      if(markBothOnSameSide)
      {
         bool markup = (EUR_dx[i] < -markSensitivity && USD_dx[i] < -markSensitivity);
         bool markdn = (EUR_dx[i] >  markSensitivity && USD_dx[i] >  markSensitivity);
            manageArrow(i,markup,markdn); 
      }
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i, bool markup, bool markdn)
{
   deleteArrow(Time[i]);
   
   if (markup) drawArrow(i,markBothBelowColor,markSymbol, 1, false);
   if (markdn) drawArrow(i,markBothAboveColor,markSymbol, 1, true);
    
   return(0);     
}              
void deleteArrow(datetime time) { ObjectDelete(UniqueID+":"+time); }

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode, int theSize, bool up) 
{
   string name  = UniqueID+":"+Time[i];
   double gapup = markDistance*iATR(NULL,0,20,i)/3.0;   
   double gapdn = markDistance*iATR(NULL,0,20,i)/12.0;   
   
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theSize);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gapup);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gapdn);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void checkLimit(string symbol, int& limit) 
{
   string checkSymbol = SymbolPrefix+symbol+SymbolSuffix;
      if (checkSymbol!=Symbol() && iClose(checkSymbol,0,0)!=0)
         limit = MathMin(Bars-1,MathMax(limit,iCustom(checkSymbol,0,indicatorFileName,"returnBars",0,0)));
}

//
//
//
//
//

void checkRiseFall(double& array[], int forSymbol, int i) 
{
   if (i==0) 
   {
      int    window = WindowFind(ShortName);
      string arrow  = "";
      if (ArrowsOnSlope) 
      {
         if (array[i]>array[i+1]) arrow = "";
         if (array[i]<array[i+1]) arrow = "";
      } 
      else 
      {
         if (array[i]>0) arrow = "";
         if (array[i]<0) arrow = "";
      }         
      string name = UniqueID+":arrow_"+Currencies[forSymbol];
         ObjectCreate(name,OBJ_LABEL,window,0,0);
            ObjectSet(name,OBJPROP_XDISTANCE,10);
            ObjectSet(name,OBJPROP_YDISTANCE,10+forSymbol*ystep);
            ObjectSet(name,OBJPROP_CORNER,1);
            ObjectSetText(name,arrow,12,"Wingdings",Colors[forSymbol]);
   }
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars); s*= 10;
   
   int r = Bars-i-1; 
      if (r<=length) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}